#!/usr/bin/php -q
<?php

// Only for use by piping!
if (isset($_SERVER['REMOTE_ADDR']))
	die;

error_reporting(0);

$_SERVER['SERVER_SOFTWARE'] = '';
$_SERVER['SERVER_NAME'] = '';
@include_once(dirname(__FILE__) . '/SSI.php');
error_reporting(E_ALL);

$data = file('php://stdin');

$headers = array();
$header_data = '';
for ($i = 0, $n = count($data); $i < $n; $i++)
{
	if (preg_match('~^(From|Subject|Content-Type|In-Reply-To|Message-ID): (.*)$~i', $data[$i], $match) != 0)
		$headers[strtolower($match[1])] = trim($match[2]);

	if (preg_match('~^References: (.*)$~i', $data[$i], $match) != 0)
		$headers['references'][] = trim($match[1]);

	$header_data .= $data[$i];

	if (trim($data[$i]) == '')
		break;
}

if (empty($headers['in-reply-to']) && !empty($headers['references']))
{
	foreach ($headers['references'] as $ref)
	{
		if (preg_match('~[a-z0-9]{32}\-(p|t|m)(\d+)~i', $ref, $match) != 0)
		{
			$headers['in-reply-to'] = $ref;
			break;
		}
	}
}

// Couldn't find it? If so just die... (Maybe we could send back a notice to the user?)
if (empty($headers['in-reply-to']) || preg_match('~[a-z0-9]{32}\-(p|t|m)(\d+)~i', $headers['in-reply-to'], $match) == 0)
{
	die;
}

// Get the message body...
$text = '';
for (; $i < $n; $i++)
	$text .= $data[$i];

// Now, try and remove common mail clients "reply to" stuff - don't want the original email really...
if (strpos($text, '----- Original Message -----') !== false)
	$text = substr($text, 0, strpos($text, '----- Original Message -----'));

// Remove any tat from either end.
$text = trim($text);

// Get the ID and type they are replying to.
preg_match('~([a-z0-9]{32})\-(p|t|m)(\d+)~i', $headers['in-reply-to'], $match);
$databaseID = $match[1] . '-' . $match[2] . $match[3];
$messageType = $match[2];
$messageID = $match[3];

// Get the users email.
preg_match('~([0-9A-Za-z=_+\-/][0-9A-Za-z=_\'+\-/\.]*@[\w\-]+(\.[\w\-]+)*(\.[\w]{2,6}))~i', $headers['from'], $match);
$email = $match[1];

// Check that this is a reply to an "actual" message.
$request = db_query("
	SELECT emailTo
	FROM {$db_prefix}log_emails
	WHERE ID_EMAIL = '$databaseID'", __FILE__, __LINE__);
list ($emailTo) = mysql_fetch_row($request);
mysql_free_result($request);

if ($emailTo != $email)
	emailError($txt['error_not_find_entry']);

// Now attempt to load the user from the database.
$request = db_query("
	SELECT *
	FROM {$db_prefix}members
	WHERE emailAddress = '$email'
		AND is_activated = 1
	LIMIT 1", __FILE__, __LINE__);
// Can't find them?
if (mysql_num_rows($request) == 0)
	emailError($txt['error_not_find_member']);
$user_settings = mysql_fetch_assoc($request);
$ID_MEMBER = $user_settings['ID_MEMBER'];
mysql_free_result($request);

// Check what groups they are in.
if (empty($user_settings['additionalGroups']))
	$user_info['groups'] = array($user_settings['ID_GROUP'], $user_settings['ID_POST_GROUP']);
else
	$user_info['groups'] = array_merge(
		array($user_settings['ID_GROUP'], $user_settings['ID_POST_GROUP']),
		explode(',', $user_settings['additionalGroups'])
	);

// Work out our board query string.
if (in_array(1, $user_info['groups']))
	$user_info['query_see_board'] = '1';
// If not an admin, the string is what they can see...
else
	$user_info['query_see_board'] = '(FIND_IN_SET(' . implode(', b.memberGroups) OR FIND_IN_SET(', $user_info['groups']) . ', b.memberGroups))';

// Right, now to do the replies, firstly reply to a topic.
if ($messageType == 't' || $messageType == 'm')
{
	// Load up the core topic details, make sure it's all legit etc...
	if ($messageType == 't')
		$request = db_query("
			SELECT t.ID_TOPIC, t.ID_BOARD, t.locked, t.ID_MEMBER_STARTED, m.subject, b.countPosts, b.permission_mode
			FROM {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS m
			WHERE t.ID_TOPIC = $messageID
				AND b.ID_BOARD = t.ID_BOARD
				AND m.ID_MSG = t.ID_FIRST_MSG
				AND $user_info[query_see_board]", __FILE__, __LINE__);
	else
		$request = db_query("
			SELECT m.ID_TOPIC, m.ID_BOARD, m.subject, t.locked, t.ID_MEMBER_STARTED, b.countPosts, b.permission_mode
			FROM {$db_prefix}messages AS m, {$db_prefix}boards AS b, {$db_prefix}topics AS t
			WHERE m.ID_MSG = $messageID
				AND b.ID_BOARD = m.ID_BOARD
				AND t.ID_TOPIC = m.ID_TOPIC
				AND $user_info[query_see_board]", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
		emailError($txt['error_topic_gone']);
	$topic_info = mysql_fetch_assoc($request);
	mysql_free_result($request);

	// Load up the users board permissions (sadly).
	$request = db_query("
		SELECT permission, addDeny
		FROM {$db_prefix}board_permissions
		WHERE ID_BOARD = " . (!empty($modSettings['permission_enable_by_board']) && $topic_info['permission_mode'] == 1 ? $topic_info[ID_BOARD] : 0) . "
			AND ID_GROUP IN (" . implode(', ', $user_info['groups']) . ")", __FILE__, __LINE__);
	$removals = array();
	$user_info['permissions'] = array();
	while ($row = mysql_fetch_assoc($request))
	{
		if (empty($row['addDeny']))
			$removals[] = $row['permission'];
		else
			$user_info['permissions'][] = $row['permission'];
	}
	mysql_free_result($request);

	// And now we get rid of the removals ;).
	if (!empty($modSettings['permission_enable_deny']))
		$user_info['permissions'] = array_diff($user_info['permissions'], $removals);

	// Right, we have the topic info, and the permissions - do they have a right to reply?
	if ($topic_info['locked'] && !allowedTo('moderate_forum'))
		emailError($txt['error_locked']);
	elseif ($topic_info['ID_MEMBER_STARTED'] == $ID_MEMBER && !allowedTo('post_reply_own'))
		emailError($txt['error_cant_reply']);
	elseif (!allowedTo('post_reply_any'))
		emailError($txt['error_cant_reply']);

	// If we get to this point - we must be doing pretty damn well. Let's make the post!
	require_once($sourcedir . '/Subs-Post.php');

	// Setup the variables.
	$msgOptions = array(
		'id' => 0,
		'subject' => strpos($topic_info['subject'], 'Re:') === 0 ? $topic_info['subject'] : 'Re: ' . $topic_info['subject'],
		'body' => $text,
	);
	$topicOptions = array(
		'id' => $topic_info['ID_TOPIC'],
		'board' => $topic_info['ID_BOARD'],
		'mark_as_read' => false,
	);
	$posterOptions = array(
		'id' => $ID_MEMBER,
		'name' => $user_settings['realName'],
		'email' => $user_settings['emailAddress'],
		'update_post_count' => $topic_info['countPosts'],
		'ip' => $user_settings['memberIP'],
	);

	// Attempt to make the post.
	createPost($msgOptions, $topicOptions, $posterOptions);
}
// What about a personal message?
elseif ($messageType == 'p')
{
	// Load up the personal message...
	$request = db_query("
		SELECT p.ID_PM, p.subject, p.ID_MEMBER_FROM
		FROM {$db_prefix}pm_recipients AS pm, {$db_prefix}personal_messages AS p, {$db_prefix}members AS mem
		WHERE pm.ID_PM = $messageID
			AND pm.ID_MEMBER = $ID_MEMBER
			AND p.ID_PM = pm.ID_PM
			AND mem.ID_MEMBER = p.ID_MEMBER_FROM", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
		emailError($txt['error_pm_not_found']);
	$pm_info = mysql_fetch_assoc($request);
	mysql_free_result($request);

	// Righty, doing well if we got here! :)
	$pm_info['subject'] = strpos($pm_info['subject'], 'Re:') === 0 ? $pm_info['subject'] : 'Re: ' . $pm_info['subject'];

	// Check they can send!
	$request = db_query("
		SELECT permission, addDeny
		FROM {$db_prefix}permissions
		WHERE ID_GROUP IN (" . implode(', ', $user_info['groups']) . ")", __FILE__, __LINE__);
	$removals = array();
	$user_info['permissions'] = array();
	while ($row = mysql_fetch_assoc($request))
	{
		if (empty($row['addDeny']))
			$removals[] = $row['permission'];
		else
			$user_info['permissions'][] = $row['permission'];
	}
	mysql_free_result($request);

	// And now we get rid of the removals ;).
	if (!empty($modSettings['permission_enable_deny']))
		$user_info['permissions'] = array_diff($user_info['permissions'], $removals);

	// Can they send?
	if (!allowedTo('pm_send'))
		emailError($txt['error_pm_not_allowed']);

	// For sending the message...
	require_once($sourcedir . '/Subs-Post.php');

	$from = array(
		'id' => $ID_MEMBER,
		'name' => $user_settings['realName'],
		'username' => $user_settings['memberName']
	);

	// Send the actual message...
	sendpm(array('to' => array($pm_info['ID_MEMBER_FROM']), 'bcc' => array()), $pm_info['subject'], $text, false, $from);
}

// Either way if we got here it's probably not worth keeping in the database - no spam man...
$deleteOld = time() - (86400 * 30);
db_query("
	DELETE FROM {$db_prefix}log_emails
	WHERE emailTo = '$email'
		OR timeSent < $deleteOld", __FILE__, __LINE__);

// Email the user upon an error.
function emailError($msg = '')
{
	global $headers, $modSettings, $mbname, $txt, $webmaster_email;

	if (!empty($modSettings['email_enable_error_reporting']))
		mail($headers['from'], $txt['error_posting_email'] . $mbname, $txt['error_posting_email_following'] . "\n\n" . $msg, 'From: ' . $webmaster_email);

	die;
}
?>