<id>
Post by Email
</id>

<version>
1.03
</version>

<mod info>
This modification is designed to allow users of your forum to reply to notifications through email and have
them appear directly onto the forum. This modification will keep track of every email sent out to ensure that
users can post securely without risk of spoofing other peoples accounts and the like.

The modification will also add an option to "Feature Settings and Options" which will allow you to specify an
email address which should be used for sending out notifications - this may be useful if you want to have
an account seperate to the standard webmaster email.

After installing this mod you will need to configure your server to "pipe" email replies from notifications to this script.
In cPanel go into Email -> Forwarding and then make the forum's email address forward to "|/home/path/to/SMF/emailpost.php" without quotes.
Where the path is the path to the script (Note that path - not the URL!) If you are not using cPanel you'll
need to set this up manually.

If you have PHP installed in a path other than /usr/bin/php you will need to change the top line of emailpost.php to
point to the correct path. Please note that you *may* also need to chmod the script "emailpost.php" to ensure it is executable.

Finally, this script includes protection to stop people from spamming your forum using email - this works by limiting
the number of replies to a notification to one - so users cannot reply to the same notification more than once. By
default users will not receive an error message back to them in the case of an error occuring - you can enable error
reporting from "Feature Settings and Options". Also note the script will require replies to notifications are made
from the same address they were sent to.
</mod info>

<author>
Matthew Wolf (a.k.a Grudge)
</author>

<homepage>
http://www.mymods.co.uk
</homepage>

<edit file>
$sourcedir/Subs-Post.php
</edit file>

<search for>
	if ($message_id !== null && empty($modSettings['mail_no_message_id']))
		$headers .= 'Message-ID: <' . md5($scripturl . microtime()) . '-' . $message_id . strstr(empty($modSettings['mail_from']) ? $webmaster_email : $modSettings['mail_from'], '@') . '>' . $line_break;
</search for>

<replace>
	// Old header info removed.
</replace>

<search for>
		foreach ($to_array as $to)
		{
			if (!mail(strtr($to, array("\r" => '', "\n" => '')), $subject, $message, $headers))
			{
				log_error(sprintf($txt['mail_send_unable'], $to));
				$mail_result = false;
			}

			// Wait, wait, I'm still sending here!
			@set_time_limit(300);
			if (function_exists('apache_reset_timeout'))
				apache_reset_timeout();
		}
</search for>

<replace>
		$sent = array();
		$need_break = substr($headers, -1) == "\n" || substr($headers, -1) == "\r" ? false : true;
		foreach ($to_array as $key => $to)
		{
			$unq_id = '';
			$unq_head = '';
			if ($message_id !== null && empty($modSettings['mail_no_message_id']))
			{
				$unq_head = md5($scripturl . microtime() . rand()) . '-' . $message_id;
				$unq_id = $need_break ? "\r\n" : '' . 'Message-ID: <' . $unq_head . strstr(empty($modSettings['mail_from']) ? $webmaster_email : $modSettings['mail_from'], '@') . ">";
			}
			if (!mail(strtr($to, array("\r" => '', "\n" => '')), $subject, $message, $headers . $unq_id))
			{
				log_error(sprintf($txt['mail_send_unable'], $to));
				$mail_result = false;
			}
			elseif (!empty($unq_head))
				$sent[] = "('$to', '$unq_head', " . time() . ")";

			// Wait, wait, I'm still sending here!
			@set_time_limit(300);
			if (function_exists('apache_reset_timeout'))
				apache_reset_timeout();
		}

		// Log each email.
		if (!empty($sent))
			db_query("
				INSERT IGNORE INTO " . $GLOBALS['db_prefix'] . "log_emails
					(emailTo, ID_EMAIL, timeSent)
				VALUES
					" . implode(',', $sent), __FILE__, __LINE__);		
</replace>

<search for>
		$mail_result = $mail_result && smtp_mail($to_array, $subject, $message, $send_html ? $headers : "Mime-Version: 1.0" . $line_break . $headers);
</search for>

<replace>
		$mail_result = $mail_result && smtp_mail($to_array, $subject, $message, $send_html ? $headers : "Mime-Version: 1.0" . $line_break . $headers, $message_id);
</replace>

<search for>
function smtp_mail($mail_to_array, $subject, $message, $headers)
</search for>

<replace>
function smtp_mail($mail_to_array, $subject, $message, $headers, $message_id = null)
</replace>

<search for>
	foreach ($mail_to_array as $i => $mail_to)
	{
</search for>

<replace>
	$sent = array();
	$need_break = substr($headers, -1) == "\n" || substr($headers, -1) == "\r" ? false : true;
	$real_headers = $headers;
	foreach ($mail_to_array as $i => $mail_to)
	{
		$unq_id = '';
		$unq_head = '';
		if ($message_id !== null && empty($modSettings['mail_no_message_id']))
		{
			$unq_head = md5($GLOBALS['scripturl'] . microtime() . rand()) . '-' . $message_id;
			$unq_id = $need_break ? "\r\n" : '' . 'Message-ID: <' . $unq_head . strstr(empty($modSettings['mail_from']) ? $webmaster_email : $modSettings['mail_from'], '@') . ">";
			$sent[] = "('$mail_to', '$unq_head', " . time() . ")";
		}
		// Fix up the headers for this email!
		$headers = $real_headers . $unq_id;
</replace>

<search for>
	fputs($socket, "QUIT\r\n");
	fclose($socket);
</search for>

<add after>
	// Log each email.
	if (!empty($sent))
		db_query("
			INSERT IGNORE INTO " . $GLOBALS['db_prefix'] . "log_emails
				(emailTo, ID_EMAIL, timeSent)
			VALUES
				" . implode(',', $sent), __FILE__, __LINE__);
</add after>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			array('check', 'enableReportPM'),
</search for>

<add after>
		array('rule'),
			array('text', 'email_from'),
			array('check', 'email_enable_error_reporting'),
</add after>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
//text for Post by Email
$txt['email_from'] = 'Email address to email from (blank for forum default)';
$txt['email_enable_error_reporting'] = 'When posting by email when an error occurs inform the user by email';
$txt['error_posting_email'] = 'An error occured submitting your post to ';
$txt['error_posting_email_following'] = 'The following error occured:';
$txt['error_locked'] = 'The topic has been locked.';
$txt['error_cant_reply'] = 'You are not allowed to reply to this topic.';
$txt['error_topic_gone'] = 'Topic could not be found - it may have been deleted.';
$txt['error_not_find_member'] = 'Your email address could not be found in the member database.';
$txt['error_not_find_entry'] = 'The email you sent your message from cannot be found in the email database - maybe you have already replied to the message?';
$txt['error_pm_not_found'] = 'The personal message you were replying to could not be found.';
$txt['error_pm_not_allowed'] = 'You do not have permission to send personal messages!';
</add before>